ORG 0x7c00

	jmp 0x0000:start			; sync weird bios segment:offset pairs on bootup 
start:
	cli					; disable interrupts until we enter unreal mode

    	xor ax, ax				; zero all the segment registers
    	mov ds, ax
    	mov es, ax
    	mov fs, ax
    	mov gs, ax
    	mov ss, ax
    
    	mov byte [drvnum] , dl			; save the boot device ID in the FAT BPB

enable_a20_fast:				; use the fast method to enable A20 gate access
    	in al, 0x92 
    	or al, 0x02
    	out 0x92, al  

init_stack:
    	mov esp, 0x7C00				; set up our stack to 0x7C00
    	mov bp, sp

    	sti

;load stage2
reset:
	MOV AH, 0
	MOV DL, [drvnum]
	INT 0x13

	JC reset


	MOV AH, 0x02   
	MOV AL, 4   
	MOV CH, 0   
	MOV CL, 0x02   
	MOV DH, 0   
	MOV DL, [drvnum]   
	MOV BX, 0x7E0
	MOV ES, BX  
	MOV BX, 0

	INT 0x13

	JC reset

	;MOV AX, 0x7E0
	;MOV DS, AX

	MOV AH, byte [drvnum]
	MOV AL, 0
	PUSH AX

	JMP 0x7E0:0000


drvnum DB 0

times 510-($-$$) db 0
	dw 0xAA55

